#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include "ido.h"
#include "hivas.h"
#include "hivaslista.h"
#include "fogadas.h"

Fogadas* ujfogadas(HivasElem* h, Ido fogad)
	{
	Fogadas* uj;
	uj = (Fogadas*)malloc(sizeof(Fogadas));
	uj->hivas = h;
	uj->fogad = (fogad.ido < h->hiv.kezd.ido) ? h->hiv.kezd : fogad;
	uj->sorszam = h->hiv.sorszam;
	uj->hossz = h->hiv.veg.ido - uj->fogad.ido;
	uj->kov = NULL;
	return uj;
	}

void torolfogadas(Fogadas* f)
	{
	free(f);
	f = NULL;
	}

FogadottLista* ujfogadottlista(HivasLista* n)
	{
	FogadottLista* uj;
	uj = (FogadottLista*)malloc(sizeof(FogadottLista));
	uj->eleje = NULL;
	uj->napi = n;
	return uj;
	}

void torol_fogadottlista(FogadottLista* f)
	{
	Fogadas* ezt = f->eleje;
	while(ezt != NULL) {
			f->eleje = f->eleje->kov;
			torolfogadas(ezt);
			ezt = f->eleje;
			}
	free(f);
	f = NULL;
	}

FogadottLista* fogadott_kigyujt(FogadottLista* f)
	{
	Fogadas* vege = f->eleje;
	HivasElem* akt;
	Ido t = f->napi->munkaelott->hiv.veg;
	for(akt = f->napi->munkaelott->kov; akt != f->napi->munkautan; akt = akt->kov) {
			if(akt->hiv.veg.ido > t.ido) {
					Fogadas* uj = ujfogadas(akt, t);
					if(f->eleje == NULL) {
							f->eleje = uj;
							vege = uj;
							}
					else {
							vege->kov = uj;
							vege = uj;
							}
					t = akt->hiv.veg;
					}
			}
	return f;
	}

void utolso(FogadottLista* f)
	{
	Fogadas* vege;
	for(vege = f->eleje; vege->kov != NULL; vege = vege->kov);
	int hossz = vege->fogad.ido - vege->hivas->hiv.kezd.ido;
	printf("\tAz utolso telefonalo adatai a(z) %d. sorban vannak, \n\t%d masodpercig vart.\n", vege->sorszam, hossz);
	}

void fogadott_kiir(FogadottLista* f)
	{
	FILE* fajl;
	fajl = fopen("sikeres.txt", "wt");
	Fogadas* ezt;
	for (ezt = f->eleje; ezt != NULL; ezt = ezt->kov) {
			fprintf(fajl, "%d ", ezt->sorszam);
			idokiir(fajl, ezt->fogad, ' ');
			idokiir(fajl, ezt->hivas->hiv.veg, '\n');
			}
	fclose(fajl);
	}

void szabadido(FogadottLista* f)
	{
	int csend = 0;
	Fogadas* ezt;
	for(ezt = f->eleje; ezt->kov != NULL; ezt = ezt->kov)
		csend += ezt->kov->fogad.ido - ezt->hivas->hiv.veg.ido;
	double szazalek = csend *100.0 / (f->napi->munkautan->hiv.kezd.ido - f->napi->munkaelott->hiv.veg.ido);
	printf("\nExtra\n");
	printf("\tAz ugyfelszolgalatos a munkaja soran %d masodpercet lazitott,\n\tez munkaidejenek %5.3f%% szazaleka.\n", csend, szazalek);
	}
